<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2012 - 2015 All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBromcard
{
  function checkMethod($params)
  {
    $err_MERCH_NAME=JText::_( 'PMB_ROMCARD_MODULE_ERR_MERCH_NAME' );
    $err_TERMINAL=JText::_( 'PMB_ROMCARD_MODULE_ERR_TERMINAL' );
    $err_BT_KEY=JText::_( 'PMB_ROMCARD_MODULE_ERR_BT_KEY' );
    
    $MERCH_NAME=trim($params->get('romcard_MERCH_NAME'));
    $TERMINAL=trim($params->get('romcard_TERMINAL'));
    $BT_KEY=trim($params->get('romcard_BT_KEY'));
    
    if($MERCH_NAME=='')
    {
      ?>
        <div class="pmb_error"><?php echo $err_MERCH_NAME;?></div>
      <?php
      return false;
    }
    else if($TERMINAL=='')
    {
      ?>
        <div class="pmb_error"><?php echo $err_TERMINAL;?></div>
      <?php
      return false;
    }
    else if($BT_KEY=='')
    {
      ?>
        <div class="pmb_error"><?php echo $err_BT_KEY;?></div>
      <?php
      return false;
    }
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('payuromania_trans_cost')+0;
    $percent_per_transaction=$params->get('payuromania_trans_percent_cost')+0;
    
    $MERCH_NAME=trim($params->get('romcard_MERCH_NAME'));
    $TERMINAL=trim($params->get('romcard_TERMINAL'));
    $BT_KEY=trim($params->get('romcard_BT_KEY'));
    
    $mode=$params->get('romcard_mode');
    $currency=$params->get('romcard_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=number_format(round($payment,2),2,".","");
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    
    require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
    $pmbf=new PMBFunctions();
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'Romcard');
    
    if($params->get('mail_pending')!=0)
    {
      $pmbf->sendConfirmationMail("asteptare",$all_params,$details,'Romcard');//send pending mail
    }
    
    
    //get the real order_id
    $db=JFactory::getDbo();
    $sql="select id from #__paymybill where order_id='".$db->escape($details['order_id'])."'";
    $db->setQuery($sql);
    $res=$db->loadObject();
    if(isset($res->id) && $res->id>0)
    {
      $real_order_id=$res->id;
    }
    else
    {
      die('PayMyBill: Saving the order failed. Please contact site admin.');
    }
    
    $PaymentDescription=$product_name;
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' ('.$details['InvNr'].')';
    }
    
    $config = JFactory::getConfig();
    $MERCHANT_EMAIL=$config->get( 'mailfrom' );
    
    $TIMESTAMP = gmdate( "YmdHis" );
    
    $BACKREF=JROUTE::_(JURI::root()."modules/mod_paymybill/return/romcard_return.php");
    
    
    
    $post_variables = Array(
		'AMOUNT'              => $payment,
    'CURRENCY'            => $currency,
    'ORDER'               => "00000".$real_order_id,
    'DESC'                => $PaymentDescription,
    'MERCH_NAME'          => $MERCH_NAME,
    'MERCH_URL'           => JURI::root(),
    'MERCHANT'            => "0000000".$TERMINAL,
    'TERMINAL'            => $TERMINAL,
    'EMAIL'               => $MERCHANT_EMAIL,
    'TRTYPE'              => "0",
    'COUNTRY'             => "",
    'MERCH_GMT'           => "",
    'TIMESTAMP'           => $TIMESTAMP,
    'NONCE'               => $MERCH_NAME . uniqid( "", TRUE ),
    'BACKREF'             => $BACKREF
    );
    
    $sData=$this->AddRomcardFields($post_variables);
    
    $P_SIGN=strtoupper( hash_hmac( "sha1",  $sData, pack( 'H*', $BT_KEY ) ) );
    
    $post_variables['P_SIGN']=$P_SIGN;
    
    $romcard_URL="https://www.secure11gw.ro/portal/cgi-bin/";//live
	  
  	if($mode=='TEST')
	  {
	    $romcard_URL="https://www.activare3dsecure.ro/teste3d/cgi-bin/";//test
	  }
    
   
    $pmb_button='Redirectionare la Romcard pentru plata';
    
    $html = '<html><head><title>Redirect</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$romcard_URL.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
  
  function AddRomcardFields($post_variables=array())
	{
    $sData="";
    if(count($post_variables)>0)
    {
      foreach($post_variables as $var)
      {
        if( strlen( $var ) == 0 )
    		{
    			$sData .= "-";
    		}
    		else
    		{
    			$sData .= strlen( $var ) . $var;
    		}
      }
    }
    return $sData;
	}
}
?>